/****************************************************************************/
/*                                                                          */
/*              ݴӿƼ޹˾                                    */
/*                                                                          */
/*              Copyright 2015 Tronlong All rights reserved                 */
/*                                                                          */
/****************************************************************************/
/****************************************************************************/
/*                                                                          */
/*              PCM1864ʼ                                               */
/*                                                                          */
/*              20150720                                              */
/*                                                                          */
/****************************************************************************/
#include "codecif.h"
#include "pcm1864_init.h"

/****************************************************************************/
/*                                                                          */
/*              궨                                                      */
/*                                                                          */
/****************************************************************************/
#define PCM18_RESET                 (0xFE)

#define PCM18_SLOT_WIDTH_32         (0u )
#define PCM18_SLOT_WIDTH_24         (1u )
#define PCM18_SLOT_WIDTH_20         (2u )
#define PCM18_SLOT_WIDTH_16         (3u )

/****************************************************************************/
/*                                                                          */
/*                                                                  */
/*                                                                          */
/****************************************************************************/
/**
 *  	λPCM1864
 *
 *  	baseAddr : PCM1864 ӿڵĻַI2CĻַ
 *
 *  	
 *
 **/
void PCM18Reset(unsigned int baseAddr)
{
	// ѡ Page 0
//    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0);

    // λ
    I2CRegWrite(baseAddr, PCM18_P0_REG0, PCM18_RESET);
}

/**
 *  	ʼ PCM1864 ģʽ slot λ
 *
 *  	baseAddr :  PCM1864 ӿڵĻַI2CĻַ
 *  		RX_Width:  Slot λ
 *                              TDM_LRCK_MODELRCK Duty Cycle in TDM Mode
 *  		             dataOff  : ʱӵصЧݵʱӸ
 *                              TX_Width:  Slot λ
 *  		dataType : ģʽ
 *
 *  			dataType ֵΪ
 *  	                PCM18_DATATYPE_I2S - I2S ģʽ \n
 *              	PCM18_DATATYPE_DSP - DSP ģʽ \n
 *              	PCM18_DATATYPE_RIGHTJ - Ҷģʽ \n
 *              	PCM18_DATATYPE_LEFTJ -  ģʽ \n
 *
 *  	
 *
 **/
void PCM18DataConfig(unsigned int baseAddr, unsigned char RX_Width, unsigned char TDM_LRCK_MODE,
               unsigned char TX_Width, unsigned char dataType)
{
    unsigned char slot1;
    unsigned char slot2;
    unsigned char temp1;

    switch(RX_Width)
    {
        case 16:
            slot1 = PCM18_SLOT_WIDTH_16;
        break;

        case 20:
            slot1 = PCM18_SLOT_WIDTH_20;
        break;

        case 24:
            slot1 = PCM18_SLOT_WIDTH_24;
        break;

        case 32:
            slot1 = PCM18_SLOT_WIDTH_32;
        break;

        default:
            slot1 = PCM18_SLOT_WIDTH_24;
        break;
    }
    slot1=slot1<<6;

    temp1=TDM_LRCK_MODE<<4;

    switch(TX_Width)
    {
        case 16:
            slot2 = PCM18_SLOT_WIDTH_16;
        break;

        case 20:
            slot2 = PCM18_SLOT_WIDTH_20;
        break;

        case 24:
            slot2 = PCM18_SLOT_WIDTH_24;
        break;

        case 32:
            slot2 = PCM18_SLOT_WIDTH_32;
        break;

        default:
            slot2 = PCM18_SLOT_WIDTH_24;
        break;
    }
    slot2=slot2<<2;

    // ģʽ slot λ
    I2CRegWrite(baseAddr, PCM18_P0_REG11, (slot1 | temp1 | slot2 | dataType));

    // ôͨ:4
    I2CRegWrite(baseAddr, PCM18_P0_REG12, 0x01);
  
    // TDMʽ£źSCK(BCK)ӳλ(1bit)
    I2CRegWrite(baseAddr, PCM18_P0_REG13, 0x01);

    // TDMʽ£źSCK(BCK)ӳλ(1bit)
    I2CRegWrite(baseAddr, PCM18_P0_REG14, 0x01);
}

/**
 *  	 PCM1864 Ĳʣ12ӣ
 *
 *  	baseAddr  :  PCM1864 ӿڵĻַI2CĻַ
 *  		RefSource : ѡ SCK_or_XTAL, SCK  XTAL(XI)
 *  		sampleRate: 
 *
 *  			sampleRate ֵΪ
 *  				FS_8000_HZ ,FS_11025_HZ ,FS_16000_HZ ,FS_22050_HZ ,FS_24000_HZ
 *  				FS_32000_HZ ,S_44100_HZ ,FS_48000_HZ ,FS_96000_HZ ,FS_192000_HZ
 *                                              ˴LRCKSCKIƵõΪ192Hz
 *  			                // fs µʽƵ
 *  				//fs = (PLL_IN * [pllJval.pllDval] * pllRval) /(2048 * pllPval).
 *  			 SCKI  ⲿ 	SCKI  = 24576 kHz
 *
 *  	
 *
 **/
void PCM18SampleRateConfig1(unsigned int baseAddr,  unsigned char RefSource, unsigned char mode,
                           unsigned int sampleRate)
{
      unsigned char temp;

    // PCM18_P0_REG40 ĬʹPLLSCKΪο
    
    // SCKԴ(XTAL)ģʽģʽʱԴѡ(PLL)
    // ADCԴΪSCKDSP2ԴΪPLLDSP1ԴΪPLL (˴д10010110)
    I2CRegWrite(baseAddr, PCM18_P0_REG32, 0x1B);

    // PLL SCK OutputSCK Outıֵ˴Ϊ2Ƶ
    I2CRegWrite(baseAddr, PCM18_P0_REG37, 0x01);
  
    // ģʽSCKBCKıֵ˴Ϊ1Ƶ
    I2CRegWrite(baseAddr, PCM18_P0_REG38, 0x00);

    // BCKLRCKıֵ˴Ϊ256Ƶ
    I2CRegWrite(baseAddr, PCM18_P0_REG39, 0xFF);

    // PLLPֵ, P=4
    I2CRegWrite(baseAddr, PCM18_P0_REG41, 0x07);

    // PLLRֵ, R=2
    I2CRegWrite(baseAddr, PCM18_P0_REG42, 0x01);

    // PLLJֵ, J=8
    I2CRegWrite(baseAddr, PCM18_P0_REG43, 0x08);

    // PLLDֵ8λ͸6λ
    I2CRegWrite(baseAddr, PCM18_P0_REG44, 0);
    I2CRegWrite(baseAddr, PCM18_P0_REG45, 0);
    
    // DSP1ʱӣƵ
    I2CRegWrite(baseAddr, PCM18_P0_REG33, 0);

    // DSP2ʱӣ2Ƶ
    I2CRegWrite(baseAddr, PCM18_P0_REG34, 0);

    // ADCʱӣ4Ƶ
    I2CRegWrite(baseAddr, PCM18_P0_REG35, 0x07);

    // GPIO0ΪڣSCKO
    I2CRegWrite(baseAddr, PCM18_P0_REG18, 0x04);
    I2CRegWrite(baseAddr, PCM18_P0_REG16, 0x03);

    // GPIO3ΪڣDOUT2
    I2CRegWrite(baseAddr, PCM18_P0_REG19, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG17, 0x50);
}

void PCM18SampleRateConfig2(unsigned int baseAddr,  unsigned char RefSource, unsigned char mode,
                           unsigned int sampleRate)
{
      unsigned char temp;

    // PCM18_P0_REG40 ĬʹPLLSCKΪο
    
    temp=1<<5;
    // SCKԴ(SCKI)ģʽʱԴģʽ(Slave)
    // ADCԴΪSCKDSP2ԴΪSCKDSP1ԴΪSCKʱӼ
    I2CRegWrite(baseAddr, PCM18_P0_REG32, 0x01);
  
    // PLLPֵ, P=8
    I2CRegWrite(baseAddr, PCM18_P0_REG41, 0x0F);

    // PLLRֵ, R=2
    I2CRegWrite(baseAddr, PCM18_P0_REG42, 0x01);

    // PLLJֵ, J=8
    I2CRegWrite(baseAddr, PCM18_P0_REG43, 0x10);

    // PLLDֵ8λ͸6λ
    I2CRegWrite(baseAddr, PCM18_P0_REG44, 0);
    I2CRegWrite(baseAddr, PCM18_P0_REG45, 0);
    
    // DSP1ʱӣƵ
    I2CRegWrite(baseAddr, PCM18_P0_REG33, 0);

    // DSP2ʱӣƵ
    I2CRegWrite(baseAddr, PCM18_P0_REG34, 0x01);

    // ADCʱӣ8Ƶ
    I2CRegWrite(baseAddr, PCM18_P0_REG35, 0x0F);

    I2CRegWrite(baseAddr, PCM18_P0_REG18, 0x00);
    I2CRegWrite(baseAddr, PCM18_P0_REG16, 0x00);

    // GPIO3ΪڣDOUT2
    I2CRegWrite(baseAddr, PCM18_P0_REG19, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG17, 0x50);
}

/**
 *  	ʼ PCM1864  ADC 
 *
 *  	baseAddr  :  PCM1864 ӿڵĻַI2CĻַ
 *  		adcGain   : ADC 
 *  		
 *
 *  			
 *  			
 *  				
 *  				
 *
 *  	
 *
 **/

void PCM18ADCInit1(unsigned int baseAddr)
{
//    unsigned char adc_gain = adcGain/0.5;

// ADCͨѡ
     //ΪPage0
    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);  
    




    // ͨ(CH1L, CH1R, CH2L, CH2R,)ѡģźţźż
    I2CRegWrite(baseAddr, PCM18_P0_REG6, 0x41);   //L1
    I2CRegWrite(baseAddr, PCM18_P0_REG7, 0x41);   //R1
    I2CRegWrite(baseAddr, PCM18_P0_REG8, 0x44);
    I2CRegWrite(baseAddr, PCM18_P0_REG9, 0x44);



    // ADCѡͨ(Ĭϲѡ)
    I2CRegWrite(baseAddr, PCM18_P0_REG10, 0x00);
/**************************************************************************************/

// PGA Value
    // ΪPage0
    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);

    // PGA(CH1L, CH1R, CH2L, CH2R)СãݶΪ32ֱ
    I2CRegWrite(baseAddr, PCM18_P0_REG1, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG2, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG3, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG4, 0x40);

    // PGAģʽԶӳ(Ĭ)

 //   I2CRegWrite(baseAddr, PCM18_P0_REG25, 0x00);


    // Զƣ
    // ƽıPGAƸͨPGAʹ
    // Զ˥ƽԶǰԶAGC
    I2CRegWrite(baseAddr, PCM18_P0_REG5, 0x86);


/*
    // PGA(DPGA)
    I2CRegWrite(baseAddr, PCM18_P0_REG15, 0x00);
    I2CRegWrite(baseAddr, PCM18_P0_REG22, 0x00);
    I2CRegWrite(baseAddr, PCM18_P0_REG23, 0x00);
    I2CRegWrite(baseAddr, PCM18_P0_REG24, 0x00);
*/
/**************************************************************************************/

// DSP_CTRLĴ(Page.0, 0x71)
    // ΪPage0
//    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);

    // 4ͨ(Ĭ)ֳȡ˲ѡͨFIRøͨ˲ĸͨ
    I2CRegWrite(baseAddr, PCM18_P0_REG113, 0x10);
/**************************************************************************************/

// ֻ(Digital Mixer)
    // ΪPage1
    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x01);

// Mix1ĸͨΪ0dB

    // Mix1_CH1L
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x00);  // Mix1_CH1Lַ
    // Mix1_CH1L
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00);
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00);
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);

    // Mix1_CH1R
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x01);  // Mix1_CH1Rַ
    // Mix1_CH1R
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00);
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00);
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);

    // Mix1_CH2L
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x02);  // Mix1_CH2Lַ
    // Mix1_CH2L
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00);
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00);
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);

    // Mix1_CH2R
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x03);  // Mix1_CH2Rַ
    // Mix1_CH2R
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00);
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00);
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);



    //ΪPage0
       I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x03);
    //Power down mic bias control
          I2CRegWrite(baseAddr, PCM18_P3_REG15, 0x00);
    //ΪPage0
             I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);

}

void PCM18ADCInit2(unsigned int baseAddr)
{
//    unsigned char adc_gain = adcGain/0.5;

// ADCͨѡ
     //ΪPage0
    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);





    // ͨ(CH1L, CH1R, CH2L, CH2R,)ѡģźţźż
    I2CRegWrite(baseAddr, PCM18_P0_REG6, 0x41);   //L1
    I2CRegWrite(baseAddr, PCM18_P0_REG7, 0x41);   //R1
    I2CRegWrite(baseAddr, PCM18_P0_REG8, 0x44);
    I2CRegWrite(baseAddr, PCM18_P0_REG9, 0x44);


    // ADCѡͨ(Ĭϲѡ)
    I2CRegWrite(baseAddr, PCM18_P0_REG10, 0x00);  
/**************************************************************************************/

// PGA Value
    // ΪPage0
//    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);  
    
    // PGA(CH1L, CH1R, CH2L, CH2R)СãݶΪ32ֱ
    I2CRegWrite(baseAddr, PCM18_P0_REG1, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG2, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG3, 0x40);
    I2CRegWrite(baseAddr, PCM18_P0_REG4, 0x40);
 
    // PGAģʽԶӳ(Ĭ)

 //   I2CRegWrite(baseAddr, PCM18_P0_REG25, 0x00);


    // Զƣ
    // ƽıPGAƸͨPGAʹ
    // Զ˥ƽԶǰԶAGC 
    I2CRegWrite(baseAddr, PCM18_P0_REG5, 0x86);


/*
    // PGA(DPGA)
    I2CRegWrite(baseAddr, PCM18_P0_REG15, 0x00); 
    I2CRegWrite(baseAddr, PCM18_P0_REG22, 0x00); 
    I2CRegWrite(baseAddr, PCM18_P0_REG23, 0x00);  
    I2CRegWrite(baseAddr, PCM18_P0_REG24, 0x00);  
*/
/**************************************************************************************/
 
// DSP_CTRLĴ(Page.0, 0x71)
    // ΪPage0
//    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);  

    // 4ͨ(Ĭ)ֳȡ˲ѡͨFIRøͨ˲ĸͨ
    I2CRegWrite(baseAddr, PCM18_P0_REG113, 0x10);  
/**************************************************************************************/
 
// ֻ(Digital Mixer)
    // ΪPage1
    I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x01);  

// Mix1ĸͨΪ0dB

    // Mix1_CH1L
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x00);  // Mix1_CH1Lַ
    // Mix1_CH1L
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00); 
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00); 
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  

    // Mix1_CH1R
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x01);  // Mix1_CH1Rַ
    // Mix1_CH1R
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00); 
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00); 
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
 
    // Mix1_CH2L
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x02);  // Mix1_CH2Lַ
    // Mix1_CH2L
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00); 
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00); 
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  

    // Mix1_CH2R
    I2CRegWrite(baseAddr, PCM18_P1_REG2, 0x03);  // Mix1_CH2Rַ
    // Mix1_CH2R
    I2CRegWrite(baseAddr, PCM18_P1_REG4, 0xA0);
    I2CRegWrite(baseAddr, PCM18_P1_REG5, 0x00); 
    I2CRegWrite(baseAddr, PCM18_P1_REG6, 0x00); 
    //ִд
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);  
    I2CRegWrite(baseAddr, PCM18_P1_REG1, 0x01);   



    //ΪPage0
       I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x03);
    //Power down mic bias control
          I2CRegWrite(baseAddr, PCM18_P3_REG15, 0x00);
    //ΪPage0
             I2CRegWrite(baseAddr, PCM18_P0_REG0, 0x00);

}
